Hex Artifact Content

Artifact 093497ea45cce241c6d15bcf75f89665717d2804:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64  n verifyRequired
0130: 50 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f  Packages() {..lo
0140: 63 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69  cal pkg pkgdomai
0150: 6e 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f  n pkgversion..lo
0160: 63 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f  cal pkgdir pkgco
0170: 6e 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64  nfigdir pkgfound
0180: 0a 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24  ...for pkg in "$
0190: 7b 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64  {require[@]}"; d
01a0: 6f 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27  o...pkgdomain=''
01b0: 0a 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27  ...pkgversion=''
01c0: 0a 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d  ....case "${pkg}
01d0: 22 20 69 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09  " in....*/*@*)..
01e0: 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28  ...pkgdomain="$(
01f0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0200: 63 75 74 20 2d 66 20 32 20 2d 64 20 27 40 27 29  cut -f 2 -d '@')
0210: 22 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e  ".....pkgversion
0220: 3d 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d  ="$(echo "${pkg}
0230: 22 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20  " | cut -f 2 -d 
0240: 27 2f 27 20 7c 20 63 75 74 20 2d 66 20 31 20 2d  '/' | cut -f 1 -
0250: 64 20 27 40 27 29 22 0a 09 09 09 09 70 6b 67 3d  d '@')".....pkg=
0260: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
0270: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
0280: 2f 27 29 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a  /')".....;;....*
0290: 2f 2a 29 0a 09 09 09 09 70 6b 67 76 65 72 73 69  /*).....pkgversi
02a0: 6f 6e 3d 22 24 28 65 63 68 6f 20 22 24 7b 70 6b  on="$(echo "${pk
02b0: 67 7d 22 20 7c 20 63 75 74 20 2d 66 20 32 20 2d  g}" | cut -f 2 -
02c0: 64 20 27 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d  d '/')".....pkg=
02d0: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
02e0: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
02f0: 2f 27 29 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a  /')".....;;....*
0300: 40 2a 29 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69  @*).....pkgdomai
0310: 6e 3d 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67  n="$(echo "${pkg
0320: 7d 22 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64  }" | cut -f 2 -d
0330: 20 27 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22   '@')".....pkg="
0340: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0350: 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27 40  | cut -f 1 -d '@
0360: 27 29 22 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61  ')".....;;...esa
0370: 63 0a 0a 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b  c....if [ -z "${
0380: 70 6b 67 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74  pkgdomain}" ]; t
0390: 68 65 6e 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e  hen....pkgdomain
03a0: 3d 22 24 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66  ="${domain}"...f
03b0: 69 0a 0a 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30  i....pkgfound='0
03c0: 27 0a 09 09 66 6f 72 20 70 6b 67 64 69 72 20 69  '...for pkgdir i
03d0: 6e 20 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b  n "/opt/appfs/${
03e0: 70 6b 67 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67  pkgdomain}/${pkg
03f0: 7d 2f 70 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b  }/platform"/${pk
0400: 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f  gversion:-*}; do
0410: 0a 09 09 09 70 6b 67 63 6f 6e 66 69 67 64 69 72  ....pkgconfigdir
0420: 3d 22 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f  ="${pkgdir}/lib/
0430: 70 6b 67 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69  pkgconfig".....i
0440: 66 20 5b 20 2d 64 20 22 24 7b 70 6b 67 64 69 72  f [ -d "${pkgdir
0450: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70  }" ]; then.....p
0460: 6b 67 66 6f 75 6e 64 3d 27 31 27 0a 09 09 09 66  kgfound='1'....f
0470: 69 0a 0a 09 09 09 43 46 4c 41 47 53 3d 22 24 7b  i.....CFLAGS="${
0480: 43 46 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64  CFLAGS} -I${pkgd
0490: 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09  ir}/include"....
04a0: 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50 50 46  CPPFLAGS="${CPPF
04b0: 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64 69 72  LAGS} -I${pkgdir
04c0: 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09 4c 44  }/include"....LD
04d0: 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53  FLAGS="${LDFLAGS
04e0: 7d 20 2d 4c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69  } -L${pkgdir}/li
04f0: 62 20 2d 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 70  b -Wl,-rpath,${p
0500: 6b 67 64 69 72 7d 2f 6c 69 62 22 0a 09 09 09 50  kgdir}/lib"....P
0510: 41 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b 70  ATH="${PATH}:${p
0520: 6b 67 64 69 72 7d 2f 62 69 6e 22 0a 09 09 09 65  kgdir}/bin"....e
0530: 78 70 6f 72 74 20 43 46 4c 41 47 53 20 43 50 50  xport CFLAGS CPP
0540: 46 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41  FLAGS LDFLAGS PA
0550: 54 48 0a 0a 09 09 09 69 66 20 5b 20 2d 64 20 22  TH.....if [ -d "
0560: 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22  ${pkgconfigdir}"
0570: 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 50 4b 47   ]; then.....PKG
0580: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 7b  _CONFIG_PATH="${
0590: 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 7d  PKG_CONFIG_PATH}
05a0: 3a 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d  :${pkgconfigdir}
05b0: 22 0a 09 09 09 09 65 78 70 6f 72 74 20 50 4b 47  ".....export PKG
05c0: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 0a 09 09 09  _CONFIG_PATH....
05d0: 66 69 0a 0a 09 09 64 6f 6e 65 0a 0a 09 09 69 66  fi....done....if
05e0: 20 5b 20 22 24 7b 70 6b 67 66 6f 75 6e 64 7d 22   [ "${pkgfound}"
05f0: 20 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a 09   = '0' ]; then..
0600: 09 09 64 69 65 20 22 50 61 63 6b 61 67 65 20 24  ..die "Package $
0610: 7b 70 6b 67 7d 2f 24 7b 70 6b 67 76 65 72 73 69  {pkg}/${pkgversi
0620: 6f 6e 3a 2d 2a 7d 40 24 7b 70 6b 67 64 6f 6d 61  on:-*}@${pkgdoma
0630: 69 6e 7d 20 6e 6f 74 20 66 6f 75 6e 64 2e 22 0a  in} not found.".
0640: 09 09 66 69 0a 09 64 6f 6e 65 0a 7d 0a 0a 66 75  ..fi..done.}..fu
0650: 6e 63 74 69 6f 6e 20 76 65 72 69 66 79 50 72 65  nction verifyPre
0660: 72 65 71 75 69 73 69 74 65 73 28 29 20 7b 0a 09  requisites() {..
0670: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65  :.}..function de
0680: 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 28 29 20  termineOsArch() 
0690: 7b 0a 09 6f 73 3d 22 24 28 75 6e 61 6d 65 20 2d  {..os="$(uname -
06a0: 73 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73  s | dd conv=lcas
06b0: 65 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a  e 2>/dev/null)".
06c0: 09 61 72 63 68 3d 22 24 28 75 6e 61 6d 65 20 2d  .arch="$(uname -
06d0: 6d 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73  m | dd conv=lcas
06e0: 65 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a  e 2>/dev/null)".
06f0: 0a 09 63 61 73 65 20 22 24 7b 61 72 63 68 7d 22  ..case "${arch}"
0700: 20 69 6e 0a 09 09 69 3f 38 36 29 0a 09 09 09 61   in...i?86)....a
0710: 72 63 68 3d 27 69 78 38 36 27 0a 09 09 09 3b 3b  rch='ix86'....;;
0720: 0a 09 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69  ..esac.}..functi
0730: 6f 6e 20 64 65 74 65 72 6d 69 6e 65 50 72 65 66  on determinePref
0740: 69 78 28 29 20 7b 0a 09 64 65 74 65 72 6d 69 6e  ix() {..determin
0750: 65 4f 73 41 72 63 68 0a 0a 09 70 72 65 66 69 78  eOsArch...prefix
0760: 73 75 66 66 69 78 3d 22 24 7b 70 6b 67 7d 2f 24  suffix="${pkg}/$
0770: 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2f 24 7b 76  {os}-${arch}/${v
0780: 65 72 73 69 6f 6e 7d 22 0a 09 70 72 65 66 69 78  ersion}"..prefix
0790: 3d 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 64  ="/opt/appfs/${d
07a0: 6f 6d 61 69 6e 7d 2f 24 7b 70 72 65 66 69 78 73  omain}/${prefixs
07b0: 75 66 66 69 78 7d 22 0a 09 64 65 73 74 64 69 72  uffix}"..destdir
07c0: 3d 22 24 28 70 77 64 29 2f 49 4e 53 54 22 0a 0a  ="$(pwd)/INST"..
07d0: 09 6d 6b 64 69 72 20 22 24 7b 64 65 73 74 64 69  .mkdir "${destdi
07e0: 72 7d 22 20 7c 7c 20 64 69 65 0a 7d 0a 0a 66 75  r}" || die.}..fu
07f0: 6e 63 74 69 6f 6e 20 70 72 65 63 6f 6e 66 69 67  nction preconfig
0800: 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ure() {..:.}..fu
0810: 6e 63 74 69 6f 6e 20 70 6f 73 74 63 6f 6e 66 69  nction postconfi
0820: 67 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  gure() {..:.}..f
0830: 75 6e 63 74 69 6f 6e 20 63 6f 6e 66 69 67 75 72  unction configur
0840: 65 28 29 20 7b 0a 09 67 6c 69 62 63 76 65 72 73  e() {..glibcvers
0850: 3d 32 2e 32 30 0a 09 67 6c 69 62 63 64 69 72 3d  =2.20..glibcdir=
0860: 22 2f 6f 70 74 2f 61 70 70 66 73 2f 63 6f 72 65  "/opt/appfs/core
0870: 2e 61 70 70 66 73 2e 72 6b 65 65 6e 65 2e 6f 72  .appfs.rkeene.or
0880: 67 2f 67 6c 69 62 63 2f 70 6c 61 74 66 6f 72 6d  g/glibc/platform
0890: 2f 24 7b 67 6c 69 62 63 76 65 72 73 7d 22 0a 09  /${glibcvers}"..
08a0: 64 79 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73 20  dynlinker="$(ls 
08b0: 22 24 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c 69  "${glibcdir}"/li
08c0: 62 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e 2a  b/ld-linux*.so.*
08d0: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a   | tail -n 1)"..
08e0: 09 69 66 20 5b 20 21 20 2d 64 20 22 24 7b 67 6c  .if [ ! -d "${gl
08f0: 69 62 63 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e  ibcdir}" ]; then
0900: 0a 09 09 64 69 65 20 27 67 6c 69 62 63 20 64 69  ...die 'glibc di
0910: 72 65 63 74 6f 72 79 20 69 73 20 6e 6f 74 20 61  rectory is not a
0920: 76 61 69 6c 61 62 6c 65 20 28 61 70 70 66 73 20  vailable (appfs 
0930: 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e 67 3f  running/working?
0940: 29 27 0a 09 66 69 0a 0a 09 43 46 4c 41 47 53 3d  )'..fi...CFLAGS=
0950: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 67  "${CFLAGS} -I${g
0960: 6c 69 62 63 64 69 72 7d 2f 69 6e 63 6c 75 64 65  libcdir}/include
0970: 22 0a 09 43 50 50 46 4c 41 47 53 3d 22 24 7b 43  "..CPPFLAGS="${C
0980: 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b 67 6c 69  PPFLAGS} -I${gli
0990: 62 63 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a  bcdir}/include".
09a0: 09 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c  .LDFLAGS="${LDFL
09b0: 41 47 53 7d 20 2d 57 6c 2c 2d 2d 72 70 61 74 68  AGS} -Wl,--rpath
09c0: 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62  ,${glibcdir}/lib
09d0: 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c   -Wl,--dynamic-l
09e0: 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65  inker,${dynlinke
09f0: 72 7d 22 0a 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  r}"..PKG_CONFIG_
0a00: 4c 49 42 44 49 52 3d 22 24 7b 67 6c 69 62 63 64  LIBDIR="${glibcd
0a10: 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66 69  ir}/lib/pkgconfi
0a20: 67 22 0a 09 65 78 70 6f 72 74 20 43 46 4c 41 47  g"..export CFLAG
0a30: 53 20 43 50 50 46 4c 41 47 53 20 4c 44 46 4c 41  S CPPFLAGS LDFLA
0a40: 47 53 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49  GS PKG_CONFIG_LI
0a50: 42 44 49 52 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75  BDIR..../configu
0a60: 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70  re --prefix="${p
0a70: 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e  refix}" --syscon
0a80: 66 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61  fdir=/etc --loca
0a90: 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72 0a 7d  lstatedir=/var.}
0aa0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75  ..function prebu
0ab0: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
0ac0: 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64  nction postbuild
0ad0: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
0ae0: 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67  ion build() {..g
0af0: 72 65 70 20 22 44 45 53 54 44 49 52 22 20 4d 61  rep "DESTDIR" Ma
0b00: 6b 65 66 69 6c 65 20 3e 2f 64 65 76 2f 6e 75 6c  kefile >/dev/nul
0b10: 6c 20 7c 7c 20 64 69 65 20 22 44 6f 6e 27 74 20  l || die "Don't 
0b20: 6b 6e 6f 77 20 68 6f 77 20 74 6f 20 62 75 69 6c  know how to buil
0b30: 64 20 74 68 69 73 20 73 6f 66 74 77 61 72 65 22  d this software"
0b40: 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66 75 6e 63 74  ...make.}..funct
0b50: 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c 6c 28 29  ion preinstall()
0b60: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0b70: 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c 28 29 20  n postinstall() 
0b80: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
0b90: 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 6d 61   install() {..ma
0ba0: 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45 53 54 44  ke install DESTD
0bb0: 49 52 3d 22 24 7b 64 65 73 74 64 69 72 7d 22 0a  IR="${destdir}".
0bc0: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65 61  }..function clea
0bd0: 6e 75 70 28 29 20 7b 0a 09 63 64 20 22 24 7b 77  nup() {..cd "${w
0be0: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
0bf0: 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20 65 78 69   1..cd .. || exi
0c00: 74 20 31 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77  t 1..rm -rf "${w
0c10: 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63  orkdir}".}..func
0c20: 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a 09 6c 6f  tion die() {..lo
0c30: 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a 09 6d 65  cal message...me
0c40: 73 73 61 67 65 3d 22 24 31 22 0a 0a 09 69 66 20  ssage="$1"...if 
0c50: 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61 67 65 7d  [ -n "${message}
0c60: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f  " ]; then...echo
0c70: 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65 73 73 61   "error: ${messa
0c80: 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a 0a 09 63  ge}" >&2..fi...c
0c90: 6c 65 61 6e 75 70 0a 0a 09 65 78 69 74 20 31 0a  leanup...exit 1.
0ca0: 7d 0a 0a 73 63 72 69 70 74 64 69 72 3d 22 24 28  }..scriptdir="$(
0cb0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
0cc0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
0cd0: 26 26 20 70 77 64 29 22 0a 69 66 20 5b 20 2d 7a  && pwd)".if [ -z
0ce0: 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20   "${scriptdir}" 
0cf0: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 55  ]; then..echo "U
0d00: 6e 61 62 6c 65 20 74 6f 20 6c 6f 63 61 74 65 20  nable to locate 
0d10: 73 63 72 69 70 74 20 64 69 72 65 63 74 6f 72 79  script directory
0d20: 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66  " >&2...exit 1.f
0d30: 69 0a 0a 63 64 20 22 24 7b 73 63 72 69 70 74 64  i..cd "${scriptd
0d40: 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  ir}" || exit 1..
0d50: 69 66 20 5b 20 2d 66 20 27 62 75 69 6c 64 2e 63  if [ -f 'build.c
0d60: 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a 09 2e 20  onf' ]; then... 
0d70: 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a  'build.conf'.fi.
0d80: 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67 73 2f 24  .if [ -d "pkgs/$
0d90: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
0da0: 70 6b 67 64 69 72 3d 22 70 6b 67 73 2f 24 7b 70  pkgdir="pkgs/${p
0db0: 6b 67 7d 22 0a 09 70 6b 67 66 69 6c 65 3d 22 24  kg}"..pkgfile="$
0dc0: 7b 70 6b 67 64 69 72 7d 2f 69 6e 66 6f 22 0a 65  {pkgdir}/info".e
0dd0: 6c 73 65 0a 09 70 6b 67 66 69 6c 65 3d 22 70 6b  lse..pkgfile="pk
0de0: 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 64  gs/${pkg}"..pkgd
0df0: 69 72 3d 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a  ir="${pkgfile}".
0e00: 66 69 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24  fi..if [ ! -e "$
0e10: 7b 70 6b 67 66 69 6c 65 7d 22 20 5d 3b 20 74 68  {pkgfile}" ]; th
0e20: 65 6e 0a 09 65 63 68 6f 20 22 49 6e 76 61 6c 69  en..echo "Invali
0e30: 64 20 70 61 63 6b 61 67 65 2e 22 20 3e 26 32 0a  d package." >&2.
0e40: 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 70 6b 67  ..exit 1.fi..pkg
0e50: 64 61 74 65 3d 22 24 28 66 6f 72 20 61 72 74 69  date="$(for arti
0e60: 66 61 63 74 20 69 6e 20 24 28 66 69 6e 64 20 22  fact in $(find "
0e70: 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65  ${pkgdir}" -type
0e80: 20 66 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72   f -print0 | xar
0e90: 67 73 20 2d 6e 20 31 20 2d 30 20 66 6f 73 73 69  gs -n 1 -0 fossi
0ea0: 6c 20 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20  l finfo --limit 
0eb0: 31 20 2d 2d 77 69 64 74 68 20 30 20 32 3e 2f 64  1 --width 0 2>/d
0ec0: 65 76 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 27  ev/null | grep '
0ed0: 5e 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d  ^[0-9][0-9][0-9]
0ee0: 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d  [0-9]-[0-9][0-9]
0ef0: 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 20 27 20 7c 20  -[0-9][0-9] ' | 
0f00: 73 65 64 20 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b  sed 's@^[^ ]* \[
0f10: 40 40 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c 20 73  @@;s@\].*@@' | s
0f20: 6f 72 74 20 2d 75 29 3b 20 64 6f 20 66 6f 73 73  ort -u); do foss
0f30: 69 6c 20 69 6e 66 6f 20 22 24 7b 61 72 74 69 66  il info "${artif
0f40: 61 63 74 7d 22 20 7c 20 61 77 6b 20 27 2f 5e 75  act}" | awk '/^u
0f50: 75 69 64 3a 2f 7b 20 70 72 69 6e 74 20 24 33 20  uid:/{ print $3 
0f60: 24 34 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5b  $4 }' | sed 's@[
0f70: 2d 3a 5d 40 40 67 3b 73 40 2e 2e 24 40 5c 2e 26  -:]@@g;s@..$@\.&
0f80: 40 27 3b 20 64 6f 6e 65 20 7c 20 73 6f 72 74 20  @'; done | sort 
0f90: 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22  -n | tail -n 1)"
0fa0: 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64  .if [ -z "${pkgd
0fb0: 61 74 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70  ate}" ]; then..p
0fc0: 6b 67 64 61 74 65 3d 22 24 28 66 69 6e 64 20 22  kgdate="$(find "
0fd0: 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65  ${pkgdir}" -type
0fe0: 20 66 20 2d 70 72 69 6e 74 66 20 27 25 54 59 25   f -printf '%TY%
0ff0: 54 6d 25 54 64 25 54 48 25 54 4d 2e 25 54 53 5c  Tm%Td%TH%TM.%TS\
1000: 6e 27 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c  n' 2>/dev/null |
1010: 20 63 75 74 20 2d 66 20 31 2d 32 20 2d 64 20 27   cut -f 1-2 -d '
1020: 2e 27 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74  .' | sort -n | t
1030: 61 69 6c 20 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e  ail -n 1)".fi...
1040: 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61   "${pkgfile}"..a
1050: 72 63 68 69 76 65 64 69 72 3d 22 24 28 70 77 64  rchivedir="$(pwd
1060: 29 2f 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64  )/ARCHIVE".workd
1070: 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b  ir="workdir-$$${
1080: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
1090: 24 7b 52 41 4e 44 4f 4d 7d 22 0a 73 72 63 66 69  ${RANDOM}".srcfi
10a0: 6c 65 3d 22 24 7b 61 72 63 68 69 76 65 64 69 72  le="${archivedir
10b0: 7d 2f 24 7b 70 6b 67 7d 22 0a 6d 6b 64 69 72 20  }/${pkg}".mkdir 
10c0: 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 22 20  "${archivedir}" 
10d0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
10e0: 76 2f 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b  v/null.mkdir "${
10f0: 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69  workdir}" || exi
1100: 74 20 31 0a 63 64 20 22 24 7b 77 6f 72 6b 64 69  t 1.cd "${workdi
1110: 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 77 6f  r}" || exit 1.wo
1120: 72 6b 64 69 72 3d 22 24 28 70 77 64 29 22 0a 0a  rkdir="$(pwd)"..
1130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 73 72 63  if [ ! -e "${src
1140: 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  file}" ]; then..
1150: 23 20 44 6f 77 6e 6c 6f 61 64 0a 09 23 23 20 43  # Download..## C
1160: 6c 65 61 6e 75 70 0a 09 72 6d 20 2d 66 20 73 72  leanup..rm -f sr
1170: 63 2e 6e 65 77 20 73 72 63 0a 0a 09 23 23 20 46  c.new src...## F
1180: 65 74 63 68 20 66 69 6c 65 0a 09 77 67 65 74 20  etch file..wget 
1190: 2d 4f 20 73 72 63 2e 6e 65 77 20 22 24 7b 75 72  -O src.new "${ur
11a0: 6c 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  l}" || exit 1...
11b0: 23 23 20 56 65 72 69 66 79 20 73 69 67 6e 61 74  ## Verify signat
11c0: 75 72 65 0a 09 73 72 63 5f 73 68 61 32 35 36 3d  ure..src_sha256=
11d0: 22 24 28 6f 70 65 6e 73 73 6c 20 73 68 61 32 35  "$(openssl sha25
11e0: 36 20 27 73 72 63 2e 6e 65 77 27 20 7c 20 73 65  6 'src.new' | se
11f0: 64 20 27 73 40 5e 2e 2a 3d 20 40 40 27 29 22 0a  d 's@^.*= @@')".
1200: 09 69 66 20 5b 20 22 24 7b 73 72 63 5f 73 68 61  .if [ "${src_sha
1210: 32 35 36 7d 22 20 21 3d 20 22 24 7b 73 68 61 32  256}" != "${sha2
1220: 35 36 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65  56}" ]; then...e
1230: 63 68 6f 20 22 53 48 41 32 35 36 20 6d 69 73 6d  cho "SHA256 mism
1240: 61 74 63 68 3a 20 20 44 6f 77 6e 6c 6f 61 64 65  atch:  Downloade
1250: 64 3a 20 24 7b 73 72 63 5f 73 68 61 32 35 36 7d  d: ${src_sha256}
1260: 20 21 3d 20 45 78 70 65 63 74 65 64 3a 20 24 7b   != Expected: ${
1270: 73 68 61 32 35 36 7d 22 20 3e 26 32 0a 0a 09 09  sha256}" >&2....
1280: 65 78 69 74 20 31 0a 09 66 69 0a 0a 09 23 23 20  exit 1..fi...## 
1290: 4d 6f 76 65 20 66 69 6c 65 20 69 6e 74 6f 20 70  Move file into p
12a0: 6c 61 63 65 0a 09 6d 76 20 73 72 63 2e 6e 65 77  lace..mv src.new
12b0: 20 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f   "${archivedir}/
12c0: 24 7b 70 6b 67 7d 22 0a 66 69 0a 0a 23 20 44 65  ${pkg}".fi..# De
12d0: 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76 65  compress archive
12e0: 0a 23 23 20 44 65 74 65 72 6d 69 6e 65 20 74 79  .## Determine ty
12f0: 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a 63 61  pe of archive.ca
1300: 73 65 20 22 24 7b 75 72 6c 7d 22 20 69 6e 0a 09  se "${url}" in..
1310: 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74 61 72 2e 78  *.tar.xz|*.tar.x
1320: 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29 0a 09 09 64  z'?'*|*.txz)...d
1330: 65 63 6f 6d 70 72 65 73 73 3d 27 78 7a 27 0a 09  ecompress='xz'..
1340: 09 3b 3b 0a 09 2a 2e 74 61 72 2e 67 7a 7c 2a 2e  .;;..*.tar.gz|*.
1350: 74 61 72 2e 67 7a 27 3f 27 2a 7c 2a 2e 74 67 7a  tar.gz'?'*|*.tgz
1360: 29 0a 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  )...decompress='
1370: 67 7a 69 70 27 0a 09 09 3b 3b 0a 09 2a 2e 74 61  gzip'...;;..*.ta
1380: 72 2e 62 7a 32 7c 2a 2e 74 61 72 2e 62 7a 32 27  r.bz2|*.tar.bz2'
1390: 3f 27 2a 7c 2a 2e 74 62 7a 32 29 0a 09 09 64 65  ?'*|*.tbz2)...de
13a0: 63 6f 6d 70 72 65 73 73 3d 27 62 7a 69 70 32 27  compress='bzip2'
13b0: 0a 09 09 3b 3b 0a 09 2a 2e 7a 69 70 7c 2a 2e 7a  ...;;..*.zip|*.z
13c0: 69 70 27 3f 27 2a 29 0a 09 09 64 65 63 6f 6d 70  ip'?'*)...decomp
13d0: 72 65 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 3b  ress='unzip'...;
13e0: 3b 0a 09 2a 29 0a 09 09 65 63 68 6f 20 22 55 6e  ;..*)...echo "Un
13f0: 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69 6f  known compressio
1400: 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c 7d  n method: ${url}
1410: 22 20 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a  " >&2....exit 1.
1420: 09 09 3b 3b 0a 65 73 61 63 0a 0a 23 23 20 44 6f  ..;;.esac..## Do
1430: 20 64 65 63 6f 6d 70 72 65 73 73 69 6f 6e 0a 63   decompression.c
1440: 61 73 65 20 22 24 7b 64 65 63 6f 6d 70 72 65 73  ase "${decompres
1450: 73 7d 22 20 69 6e 0a 09 75 6e 7a 69 70 29 0a 09  s}" in..unzip)..
1460: 09 75 6e 7a 69 70 20 22 24 7b 73 72 63 66 69 6c  .unzip "${srcfil
1470: 65 7d 22 20 7c 7c 20 64 69 65 20 27 55 6e 61 62  e}" || die 'Unab
1480: 6c 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73  le to uncompress
1490: 20 61 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 09   archive'...;;..
14a0: 2a 29 0a 09 09 22 24 7b 64 65 63 6f 6d 70 72 65  *)..."${decompre
14b0: 73 73 7d 22 20 2d 64 63 20 22 24 7b 73 72 63 66  ss}" -dc "${srcf
14c0: 69 6c 65 7d 22 20 7c 20 74 61 72 20 2d 78 66 20  ile}" | tar -xf 
14d0: 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65  - || die 'Unable
14e0: 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61   to uncompress a
14f0: 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 65 73 61  rchive'...;;.esa
1500: 63 0a 0a 23 23 20 43 6c 65 61 6e 75 70 20 73 6f  c..## Cleanup so
1510: 75 72 63 65 0a 72 6d 20 2d 66 20 73 72 63 0a 0a  urce.rm -f src..
1520: 23 20 49 66 20 77 65 20 6a 75 73 74 20 68 61 76  # If we just hav
1530: 65 20 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c  e one directory,
1540: 20 75 73 65 20 74 68 61 74 20 64 69 72 65 63 74   use that direct
1550: 6f 72 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20  ory.dir="$(echo 
1560: 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64  *)".if [ -e "${d
1570: 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76  ir}" ]; then..mv
1580: 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69   "${dir}"/* ..fi
1590: 0a 0a 23 20 56 65 72 69 66 79 20 70 72 65 2d 72  ..# Verify pre-r
15a0: 65 71 75 69 73 69 74 65 73 20 61 72 65 20 6d 65  equisites are me
15b0: 74 0a 76 65 72 69 66 79 52 65 71 75 69 72 65 64  t.verifyRequired
15c0: 50 61 63 6b 61 67 65 73 20 7c 7c 20 64 69 65 20  Packages || die 
15d0: 27 52 65 71 75 69 72 65 64 20 70 61 63 6b 61 67  'Required packag
15e0: 65 73 20 6d 69 73 73 69 6e 67 27 0a 76 65 72 69  es missing'.veri
15f0: 66 79 50 72 65 72 65 71 75 69 73 69 74 65 73 20  fyPrerequisites 
1600: 7c 7c 20 64 69 65 20 27 50 72 65 72 65 71 75 69  || die 'Prerequi
1610: 73 69 74 69 65 73 20 66 61 69 6c 65 64 27 0a 0a  sities failed'..
1620: 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a  # Start logging.
1630: 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d  set -x..# Determ
1640: 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73 0a 64  ine properties.d
1650: 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a  eterminePrefix..
1660: 23 20 53 74 61 72 74 20 74 68 65 20 62 75 69 6c  # Start the buil
1670: 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c  d.preconfigure |
1680: 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67  | die 'preconfig
1690: 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66  ure failed'.conf
16a0: 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63 6f  igure || die 'co
16b0: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
16c0: 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c  postconfigure ||
16d0: 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67   die 'postconfig
16e0: 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ure failed'..pre
16f0: 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72  build || die 'pr
1700: 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 62  ebuild failed'.b
1710: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62 75 69  uild || die 'bui
1720: 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 62  ld failed'.postb
1730: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73  uild || die 'pos
1740: 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a  tbuild failed'..
1750: 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  preinstall || di
1760: 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61  e 'preinstall fa
1770: 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c  iled'.install ||
1780: 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20 66 61   die 'install fa
1790: 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c  iled'.postinstal
17a0: 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e  l || die 'postin
17b0: 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28  stall failed'..(
17c0: 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67 65 74  ..case "${target
17d0: 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74  mode}" in...inst
17e0: 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72 3d 22  all)....appdir="
17f0: 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c 64 69  $(appfsinstalldi
1800: 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69  r)/${prefixsuffi
1810: 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20  x}"....mkdir -p 
1820: 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09 09 09  "${appdir}".....
1830: 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24  cd "${destdir}/$
1840: 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65 78 69  {prefix}" || exi
1850: 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a  t 1.....cp -rp *
1860: 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09 09 09   "${appdir}"....
1870: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
1880: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
1890: 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24 7b   -0 touch -t "${
18a0: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
18b0: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
18c0: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
18d0: 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b   touch -m -t "${
18e0: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
18f0: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1900: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1910: 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b   touch -a -t "${
1920: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a  pkgdate}"....;;.
1930: 09 09 61 72 63 68 69 76 65 29 0a 09 09 09 61 72  ..archive)....ar
1940: 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73 63 72  chivefile="${scr
1950: 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24  iptdir}/${pkg}-$
1960: 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f  {version}-$(echo
1970: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20   "${pkgdate}" | 
1980: 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29 2d 24  sed 's@\.@@g')-$
1990: 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09  {domain}.cpio"..
19a0: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
19b0: 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e  /${prefix}/../..
19c0: 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  /.." || exit 1..
19d0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
19e0: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
19f0: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
1a00: 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d  h -t "${pkgdate}
1a10: 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65  "....find "${pre
1a20: 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69  fixsuffix}" -pri
1a30: 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74  nt0 | xargs -0 t
1a40: 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b  ouch -m -t "${pk
1a50: 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20  gdate}"....find 
1a60: 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  "${prefixsuffix}
1a70: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
1a80: 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74  s -0 touch -a -t
1a90: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
1aa0: 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73  .find "${prefixs
1ab0: 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c  uffix}" | sort |
1ac0: 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a   cpio --owner 0:
1ad0: 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22  0 -H newc -o > "
1ae0: 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22 0a  ${archivefile}".
1af0: 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c  ...;;..esac.) ||
1b00: 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73 74   die 'final inst
1b10: 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64 27  allation failed'
1b20: 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20  ..cleanup..exit 
1b30: 30 0a                                            0.